// 页面加载时自动填充账号和密码
window.addEventListener('load', function() {
  const savedAccount = localStorage.getItem('account');
  const savedPassword = localStorage.getItem('password');

  if (savedAccount) {
    document.getElementById('account').value = savedAccount;
  }

  if (savedPassword) {
    document.getElementById('password').value = savedPassword;
  }
});

document.getElementById('stepsForm').addEventListener('submit', function (event) {
  event.preventDefault();

  const account = document.getElementById('account').value;
  const password = document.getElementById('password').value;
  const steps = document.getElementById('steps').value;

  // 保存账号和密码到 localStorage
  localStorage.setItem('account', account);
  localStorage.setItem('password', password);

  const apiUrl = `https://steps.api.030101.xyz/api?account=${encodeURIComponent(account)}&password=${encodeURIComponent(password)}&steps=${encodeURIComponent(steps)}`;

  fetch(apiUrl, { method: 'GET' })
    .then(response => response.json())
    .then(data => {
      document.getElementById('responseMessage').textContent = `反馈: ${data.message || '提交成功'}`;
    })
    .catch(error => {
      document.getElementById('responseMessage').textContent = '提交失败，请稍后再试 可尝试使用vpn';
    });
});

window.addEventListener('DOMContentLoaded', function() {
  var viewportMeta = document.querySelector('meta[name="viewport"]');
  if (viewportMeta) {
    // 如果已存在 viewport 元素，修改其内容
    viewportMeta.setAttribute('content', 'width=device-width, initial-scale=1, user-scalable=no');
  } else {
    // 如果不存在，则动态创建一个
    var newMeta = document.createElement('meta');
    newMeta.setAttribute('name', 'viewport');
    newMeta.setAttribute('content', 'width=device-width, initial-scale=1, user-scalable=no');
    document.head.appendChild(newMeta);
  }
});